stages:
  - build
  - test

variables:
  DOCKER_DRIVER: overlay2

  #--> IMAGE TAGS
  IMAGE_PHP_TAG: $CI_REGISTRY_IMAGE/build/php:$CI_COMMIT_REF_SLUG
  IMAGE_PHP_TAG_LATEST: $CI_REGISTRY_IMAGE/build/php:latest
  #<-- IMAGE TAGS

.job_docker_dind_template: &job_docker_dind
  image:
    name: docker:stable
  services:
    - docker:stable-dind
  before_script:
    - docker version
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY

build:php:
  <<: *job_docker_dind
  stage: build
  script:
    - docker pull $IMAGE_PHP_TAG_LATEST || true

    - docker build
      --cache-from $IMAGE_PHP_TAG_LATEST
      -f ./docker/php/Dockerfile
      --target debug
      -t $IMAGE_PHP_TAG -t $IMAGE_PHP_TAG_LATEST .

    - docker push $IMAGE_PHP_TAG
    - docker push $IMAGE_PHP_TAG_LATEST
  only:
    changes:
      - docker/php/**/*

test:
  stage: test
  image:
    name: $IMAGE_PHP_TAG
  cache:
    key: vendor-${CI_COMMIT_REF_SLUG}
    paths:
      - vendor/
  script:
    - composer install --no-interaction
    - ./vendor/bin/psalm

    - xdebug ./vendor/bin/phpunit --testsuite unit --coverage-text --colors=never
#    - php /vendor/bin/phpunit --testsuite functional
  coverage: '/^\s*Lines:\s*\d+.\d+\%/'
